ID	MACRO
	DB CR,LF,'                {A|S} CONV2WP Version 1.2 - (06/25/93)'
#EM
;92/04/25 Version 1.0
;92/05/05 Version 1.1 - tabs begin paragraph if expanded
;93/06/25 Version 1.2 - Added Registered to msg.

SPACE	EQU ' '
CR	EQU 0DH
LF	EQU 0AH
SRT	EQU 0DH
TAB	EQU 09H
EXTAB	EQU 255

S0000	SEGMENT
	ASSUME CS:S0000,DS:S0000,ES:S0000,SS:S0000

	ORG 100H

	MOV SP,OFFSET PRGSTK	;Set local stack
	PUSH CS			;FREE memory
	POP ES
	MOV BX,OFFSET PRGSTK
	ADD BX,0FH
	MOV CL,4
	SHR BX,CL
	MOV AH,4AH
	INT 21H			;Release memory

;The parameter field starts at PSP+81H.
;Parse file names
; 1. parse it for a non-space		pointer to input file name
; 2. parse it for a space
; 3. insert 0	(make an ASCIIZ string of the name)
; 4. parse it for a non-space		pointer to output file name
; 5. parse it for a space/cr
; 6. insert 0	(make an ASCIIZ string of the name)
; 7. open input file with handle.
; 8. open output file with handle.

	MOV SI,81H		;Point at the parameter area
IFNL:	LODSB
	CMP AL,CR
	JNZ IFNL0
	MOV DX,OFFSET IFNS	;Input file not specified
FERR:	PUSH DX
	CALL HELLO
	POP DX
	CALL MSG
	MOV AX,4C00H	;Terminate
	INT 21H

IFNL0:	CMP AL,SPACE
	JZ IFNL		;Eat spaces
	DEC SI
	MOV IFNP,SI	;Save pointer to start of input file name.
	INC SI
IFNL1:	LODSB
	CMP AL,CR
	JNZ OFNL0
OFNLX:	MOV DX,OFFSET OFNS	;"Output file not specified" and terminate
	JMP FERR

OFNL0:	CMP AL,SPACE
	JNZ IFNL1
	DEC SI
	MOV BYTE [SI],0	;Need null terminator
	MOV IFNEP,SI
	INC SI
OFNL:	LODSB
	CMP AL,CR
	JZ OFNLX	;"Onput file not specified" and terminate
OFNL1:	CMP AL,SPACE	;Eating separating spaces
	JZ OFNL
	DEC SI
	MOV OFNP,SI	;Save pointer to start of output file name.
	INC SI
OFNL2:	LODSB		;Searching for end of name
	CMP AL,CR
	JNZ OFNL2
	DEC SI
	MOV BYTE [SI],0	;Need null terminator
	MOV OFNEP,SI
	MOV AX,3D00H		;Open convert file
	MOV DX,OFFSET CVRTDAT
	INT 21H
	JNC OCF
	MOV DX,OFFSET CFOERR	;Can't open convert.DAT
	JMP FERR

OCF:	MOV CFHD,AX
	MOV DX,OFFSET RDCF
	CALL MSG
	CALL DOCNV
CCF:	MOV AX,3E00H	;Close convert file
	MOV BX,CFHD
	INT 21H
OIF:	MOV AX,3D00H	;Open input file
	MOV DX,IFNP
	INT 21H
	JNC OOF
	MOV DX,OFFSET IFOERR
	JMP FERR

OOF:	MOV IFHD,AX	;Save input file handle
	MOV AH,3CH
	MOV CX,20H
	MOV DX,OFNP
	INT 21H		;Open input file
	JNC BEGIN
	MOV DX,OFFSET OFERRM
RDER1:	CALL CLSIF		;Close the input file first
	JMP FERR

RDERR:	MOV DERROR,AL
	MOV DX,OFFSET IFRERR	;Error while reading
	MOV ERRPTR,DX
CLOSE:	CALL WRBLK
CCSER:	CALL CLSIF
	MOV AX,3E00H	;Close output file
	MOV BX,OFHD WORD
	INT 21H
	MOV DX,OFFSET FILE
	CALL MSG
	MOV DX,OFFSET REQ
	CALL MSG
	MOV DI,[IFNEP]
	MOV BYTE PTR [DI],'$'
	MOV DX,IFNP
	CALL MSG
	MOV DX,OFFSET CONVRT
	CALL MSG
	MOV DI,[OFNEP]
	MOV BYTE PTR [DI],'$'
	MOV DX,OFNP
	CALL MSG
	MOV DX,OFFSET ENDLN
	CALL MSG
	CMP BYTE DERROR,0
	JZ EXIT
	MOV DX,ERRPTR
	CALL MSG
EXIT:	MOV AX,4C00H
	INT 21H


BEGIN:	MOV OFHD,AX		;Save output file handle
	XOR DX,DX		;Initialize counter
	MOV DI,OFFSET WTBUF	;Initialize write pointer
	MOV SI,OFFSET PREFIX	;Source for prefix
	MOV CX,04CH
CPYL:	LODSB			;Copy buffer to output file
	CALL STOWIT
	LOOP CPYL
;Now we read from the input file
RDBLK:	PUSH	DX		;Stash count
	MOV DX,OFFSET RDBUF
	MOV CX,800H
	MOV BX,IFHD		;Input file handle
	MOV AH,3FH
	INT 21H
	POP DX			;Count
	JNC RDBLK1		;Error while reading input file
	JMP RDERR


RDBLK2:	JMP CLOSE

RDBLK1:	MOV CX,AX		;Bytes read in AX
	JCXZ RDBLK2		;Got none?
	MOV SI,OFFSET RDBUF	;Point to read buffer
SCANB:	LODSB
;With character do:		;AL= character to process
;Convert a single CR,LF into a space.
;Convert a single CR,LF followed by a space to a [Hrt]
;Convert multiple CR,LF into a like number of [Hrt]
;ͻ
;              Finite state automata structure                 
;Ķ
;Input character:   Character X   CR       LF       SP     
;͹
;St 1                    X->1    ->2    X->1      X->1
;Ķ
;St 2CR               CR,X->1   X->2     ->3   CR,X->1
;Ķ
;St 3CR,LF         SP,   X->1    ->4SP, X->5   HR,X->1
;Ķ
;St 4CR,LF,CR      SP,CR,X->1SP,X->2HR,HR->5SP,CR,X->1
;Ķ
;St 5CR,LF,CR,LF         X->1    ->6    X->1      X->1
;Ķ
;St 6CR,LF,CR,LF,CR   CR,X->1   X->2  HR ->5   CR,X->1
;ͼ
	MOV BYTE PTR CHAR,AL
	CMP AL,TAB
	JNZ CHL0
	CMP BYTE PTR TABLOC,EXTAB
	JNZ CHL0
SPR:	CMP BYTE PTR STATE,2
	JB SET1
	JE CRSET1
	CMP BYTE PTR STATE,3
	JNE SPR1
	CALL HRT
	JMP SET1
SPR1:	CMP BYTE PTR STATE,5
	JE SET1
	JA CRSET1
	CALL BLK
CRSET1:	CALL CROUT
SET1:	MOV BYTE PTR STATE,1
CHOUT:	MOV AL,[CHAR]
	JMP NEXT	;other characters

CHL0:	CMP AL,LF
	JZ LFR
CHL1:	CMP AL,CR
	JZ CRR
CHL2:	CMP AL,SPACE
	JZ SPR
CHL3:	CMP BYTE PTR STATE,3	;X routine same as space except for 3
	JNZ SPR
	CALL BLK
	JMP SET1

PUTIT:	CALL STOWIT		;ASCII character
	JMP SKIPC
NEXT:	CALL DOCHR		;WordPerfect Character set character
SKIPC:	LOOP SCANB		;Skip a character
	JMP RDBLK

LFR:	MOV BL,[STATE]
	MOV BH,0
	DEC BX
	SHL BX,1
	JMP LFR0.[BX]

;	State changes on CR
;From	001 010 011 100 101 110	2,4,6->2	Add 1 & test for odd
;To	010 010 100 010 110 010 1,3,5->2,4,6	replace odd with 2
CRR:	TEST BYTE PTR STATE,1
	JNZ CRST		;JMP if odd
	CMP BYTE PTR STATE,4
	JNE CRXO
	CALL BLK
CRXO:	MOV AL,[CHAR]
	CALL DOCHR
CRST:	ADD BYTE PTR STATE,1
	TEST BYTE PTR STATE,1
	JZ CHGST		;JMP if even
	MOV BYTE PTR STATE,2
CHGST:	JMP SKIPC

LFR0	DW LFR1,LFR2,LFR3,LFR4,LFR1,LFR6

LFR1:	MOV BYTE PTR STATE,1
	JMP CHOUT
LFR2:	MOV BYTE PTR STATE,3
	JMP SKIPC
LFR3:	CALL BLK
	MOV BYTE PTR STATE,5
	JMP CHOUT
LFR4:	CALL HRT
LFR6:	CALL HRT
	MOV BYTE PTR STATE,5
	JMP SKIPC

BLK:	MOV AL,SRT
	JMP STOWIT
HRT:	MOV AL,LF
	JMP STOWIT
CROUT:	MOV AL,CR
	JMP DOCHR
LFOUT:	MOV AL,LF
	JMP DOCHR
CLSIF:	MOV AX,3E00H	;Close input file
	MOV BX,IFHD
	INT 21H
	RET

DOCHR:	MOV BX,OFFSET TABLE
	MOV AH,0
	SHL AX,1	;Times 2
	ADD BX,AX	;Point into table
	MOV AX,[BX]	;Get word
	CMP AX,EXTAB
	JNZ DOCHR1
TABR:	PUSH SI
	PUSH CX
	MOV SI,OFFSET TABD
	MOV CX,8
CPYLP:	LODSB
	CALL STOWIT
	LOOP CPYLP
	LODSB
	POP CX
	POP SI
	JMP STOWIT

DOCHR1:	CMP AH,0
	JE STOWIT	;Set 0 is 1 byte
	CALL STOWC0	;Otherwise do 4 bytes
	MOV AL,[BX]
	CALL STOWIT
	MOV AL,[BX+1]
	CALL STOWIT
STOWC0:	MOV AL,0C0H
STOWIT:	STOSB
	INC	DX
	CMP	DX,800H
	JB	STOWX
WRBLK:	PUSH BX
	PUSH	CX
	MOV	CX,DX
	MOV	DX,OFFSET WTBUF
	MOV	BX,OFHD
	MOV	AH,40H
	INT	21H
	POP	CX
	POP BX
	JC WRERR
	XOR	DX,DX
	MOV	DI,OFFSET WTBUF
STOWX:	RET

WRERR:	POP DX		;DUMP return address
	MOV DERROR,AL
	MOV DX,OFFSET OFWERR
	MOV ERRPTR,DX
	JMP CCSER

;Entry at GETCH to get a character from the Convert File.
RDBCF:	MOV DX,OFFSET RDBUF	;Use the read buffer
	MOV CX,800H		;Buffer size
	PUSH BX
	MOV BX,CFHD		;Convert file handle
	MOV AH,3FH		;Read from file
	INT 21H			;Do it
	POP BX
	JNC RDBCF1		;Bypass error routine
RDCER:	MOV DX,OFFSET CFRERR
	JMP FERR		;Error while reading convert file
RDBCF1:	MOV CX,AX		;Bytes read in AX
	JCXZ RDCER		;Got none? ERROR
	MOV SI,OFFSET RDBUF	;Point to read buffer
GETCH:	JCXZ RDBCF		;If CX is zero, then read another block
	LODSB			;Get character
	DEC CX
	CMP AL,SPACE
	JZ GETCH		;Swallow spaces
	RET			;We return 0 if eof

;Call to process convert file into TABLE
DOCNV:	MOV BX,256		;All 256 characters.
	MOV CX,0		;Sets CFC to 0 for initial call to GETCH
	MOV DI,OFFSET TABLE	;Where to put them
	XCHG CX,BX		;Count to CX, CFC to BX
FILTAB:	XCHG CX,BX		;Count to BX, CFC to CX for GETCH
	CALL GETNUM		;Get our character
	STOSB			;Put it in the table
	CALL GETNUM		;Get character set
	STOSB			;Put it in the table
	CALL SPIN		;Eat the rest of the line
	XCHG CX,BX		;Count to CX, CFC to BX
	LOOP FILTAB		;Continue until we do all 256
	RET

;Entry at SPIN - moves to the beginning of the next line.
SPIN1:	CALL GETCH	;Eat characters til cr,lf
	CMP AL,CR
	JNZ SPIN1
SPIN:	CALL GETCH	;Presume we ate the CR already	21,3cr,lf
	CMP AL,LF
	JNZ SPIN1
	RET

;Call to get a number from the input file; CX & SI changed by GETCH
GETNUM:	PUSH BX		;Returns number in AL
	MOV BL,0	;Start with 0
GN1:	CALL GETCH	;Get a character
	SUB AL,'0'
	JB GNX
	CMP AL,9
	JA GNX
	MOV BH,AL
	MOV AL,10
	MUL BL
	ADD AL,BH
	MOV BL,AL
	JMP GN1
GNX:	MOV AL,BL
	POP BX
	RET

HELLO:	MOV DX,OFFSET IDMSG
	MOV AH,9
	INT 21H
	MOV AH,8
	INT 21H
	MOV DX,OFFSET IDMSG1
	MOV AH,9
	INT 21H
	MOV DX,OFFSET REG
	MOV AH,9
	INT 21H
	MOV DX,OFFSET IDMSG2
MSG:	MOV AH,9
	INT 21H
	RET


IDMSG	EQU $
ID
	DB CR,LF
	DB CR,LF,'  (C) 1992 by Abstract Systems, etc.                      All rights reserved.'
	DB CR,LF,'      191 White Oaks Road, Williamstown, MA 01267-2259    Phone: (413) 458-3597'
	DB CR,LF
	DB CR,LF,'CONV2WP reads an input file of hex bytes and creates a WordPerfect 5.X document'
	DB CR,LF,'file with the hex bytes converted to WordPerfect extended characters according'
	DB CR,LF,'to the data provided in the file CONV2WP.DAT.  CONV2WP creates WordPerfect'
	DB CR,LF,'paragraphs using soft returns according to the following rules:'
	DB CR,LF,'    Convert a single CR,LF to a space ([Srt]).'
	DB CR,LF,'    Convert a single CR,LF followed by a space or an expandable TAB to a [Hrt].'
	DB CR,LF,'    Convert multiple CR,LF''s into a like number of [Hrt]''s.'
	DB CR,LF,'All other CR or LF characters will be converted to the WordPerfect character'
	DB CR,LF,'specified in CONV2WP.DAT.  CONV2WP.DAT must contain 256 single line entries of'
	DB CR,LF,'the form "n,m [ignored comment]".  The first line contains the WordPerfect'
	DB CR,LF,'character and set byte 00 gets converted to; the second line the WordPerfect'
	DB CR,LF,'character and set the byte 01 gets converted to, etc.  Spaces are ignored; the'
	DB CR,LF,'WordPerfect character number must be separated from the set number by any'
	DB CR,LF,'non-space character.  Examples of the first three lines:'
	DB CR,LF,'128,0	;0   Nulls should never be in the file'
	DB CR,LF,'  7,5	;1   Hollow happy face'
	DB CR,LF,'  8,5	;2   Solid happy face                         (256 total entries)'
	DB CR,LF
	DB CR,LF,'Press any key.$'
IDMSG1	DB CR,'      Some special characters that may be chosen include:'
	DB CR,LF
	DB CR,LF,'   10,0  ;Hard return (normally at 10)    11,0  ;Soft page   (normally at 11)'
	DB CR,LF,'   12,0  ;Hard page   (normally at 12)   128,0  ;Skip or delete character'
	DB CR,LF,'  160,0  ;Hard space                     169,0  ;Hard hyphen (normally at 45)'
	DB CR,LF,'  172,0  ;soft hyphen (normally at 45)     2,0  ;Insert page number'
	DB CR,LF,'  255,0  ;Tab         (normally at  9)  [Special function for CONV2WP]'
	DB CR,LF
	DB CR,LF,'          Usage: CONV2WP [d:][\path\]inp-file [d:][\path\]out-file'
	DB CR,LF
	DB CR,LF,'Registered to: '
	DB '$'

IFNS	DB 'Input file not specified.',CR,LF,"$"
OFNS	DB 'Output file not specified.',CR,LF,"$"
CFOERR	DB 'Unable to open CONV2WP.DAT',CR,LF,'$'
CFRERR	DB 'Error '
RDCF	DB 'Reading CONV2WP.DAT$'
IFOERR	DB 'Unable to open input file.',CR,LF,'$'
OFERRM	DB 'Unable to create output file.',CR,LF,'$'

IFRERR	DB 'Error reading input file.  Output file may be incomplete.',CR,LF,'$'
OFWERR	DB 'Error writing output file.  Output file may be incomplete',CR,LF,'$'

FILE	DB CR,'                   ',CR,LF

	DB 'Hello, '
REG	DB 'Abstract Systems, etc.$'

REQ	DB ', per your request, file',CR,LF,'$'
CONVRT	DB         ' has been converted to WordPerfect format file',CR,LF,'$'
ENDLN	DB         ' using CONV2WP.DAT.'
IDMSG2	DB CR,LF,'$'

CVRTDAT	DB 'CONV2WP.DAT',0

PREFIX	DB 0FFH,'WPC'
	DW 4CH,0
	DB 1,0AH
	DB 6 DUP(0),0FBH,0FFH
	DB 5,0,32H,5 DUP(0),6
	DB 0,8,3 DUP(0),42H
	DB 3 DUP(0),8,0
	DB 2,3 DUP(0),4AH
	DB 17H DUP(0),8,0
	DB 7CH,0,78H,5 DUP(0)

TABD	DB 0C1H,0	;WordPerfect Tab
	DW 0,0,0	;Use 255,0 to get
	DB 0C1H

STATE	DB 5
CHAR	DB 0
IFNP	DW 0	;Input file name pointer
IFNEP	DW 0	;Input file name end pointer
IFHD	DW 0	;Input file handle
OFNP	DW 0	;Output file name pointer
OFNEP	DW 0	;Output file name end pointer
OFHD	DW 0	;Output file handle
CFHD	DW 0	;Convert file handle
DERROR	DB 0
ERRPTR	DW 0
TABLE	EQU $
TABLOC	EQU $+9*2
RDBUF	EQU $+0200H
WTBUF	EQU $+0200H+0800H
PRGSTK	EQU $+0200H+0800H+0800H+0100H

	S0000 ENDS	
END
